SystemOrganization addCategory: #'PW-Utilities'!

!ALFormDataParser methodsFor: '*pw-utilities' stamp: 'chc 6/21/2016 07:46'!
parseAssociation
	| key value withpluses |
	key := in get.
	in get.
	withpluses := ((in reading ending: [ :e | '&' includes: e ]) rest) printString.
	value := withpluses replaceAll: $+ with: Character space.
	^ key -> value
	
	! !

!String methodsFor: '*pw-utilities' stamp: 'chc 1/28/2016 12:41'!
asCapitalizedPhrase
	|read words currentWord capitalizedWord|
	(self noneSatisfy: [:ea | ea isLowercase] ) ifTrue: [^ self].
	words _ WriteStream on: String new.
	read _ ReadStream on: self.
	[read atEnd] whileFalse:
		[currentWord _ WriteStream on: String new.
		currentWord nextPut: read next.
		[|x| x _ read peek. x isNil or: [x isUppercase]] whileFalse:
			[currentWord nextPut: read next].
		capitalizedWord _ currentWord contents capitalized.
			(#(Of In At A Or To By) includes: capitalizedWord)
				ifTrue: [capitalizedWord _ capitalizedWord asLowercase].
		words nextPutAll: capitalizedWord.
		words nextPutAll: ' '].
	words skip: -1.
	^ words contents ! !

TestCase subclass: #PEGWikiToolTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PW-Utilities'!

!PEGWikiToolTest methodsFor: 'as yet unclassified' stamp: 'chc 6/23/2016 08:11'!
testListenerRunningOnPort8624
	|processname|
	processname := (ProcessBrowser new processList select: [:ea| ea name match: 'listener: 8624']) first name.
	self assert: (processname = 'listener: 8624')! !

TestCase subclass: #PWRestfulLocatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PW-Utilities'!

!PWRestfulLocatorTest methodsFor: 'as yet unclassified' stamp: 'chc 6/27/2016 08:22'!
testSingleton
	"There should only ever be one instance of PWRestfulLocator"
	self assert: (PWRestfulLocator allInstances size <= 1)! !

!Object methodsFor: '*pw-utilities' stamp: 'chc 1/28/2016 12:41'!
labelForSelector: aSymbol
	^ aSymbol asCapitalizedPhrase
! !

Object subclass: #PEGWikiTool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PW-Utilities'!

!PEGWikiTool commentStamp: 'chc 3/22/2016 09:27' prior: 0!
Start PEGWiki with: 

PEGWiki start 

This depends on the PWModelConfiguration singleton being populated so that requests like 

PWModelConfiguration instance valueAt: #port

return values. !

!PEGWikiTool class methodsFor: 'startup list' stamp: 'chc 6/23/2016 08:20'!
initialize
	Smalltalk addToStartUpList: self! !

!PEGWikiTool class methodsFor: 'starting the server' stamp: 'chc 6/23/2016 08:17'!
startALExamples
	"use this to start the app to see the examples page included with Altitude"
	(ALServer on: 8624 application: ALExampleApplication new) start
! !

!PEGWikiTool class methodsFor: 'starting the server' stamp: 'chc 6/23/2016 08:54'!
startPEGWiki
"use this to start the app"
	| authenticator app | 
	authenticator := ALMemoryAuthenticator new. 
	authenticator register: 'chriscunnington'
 					username: (PWSeasidePrefsModel instance valueAt: #username)
 					password: (PWSeasidePrefsModel instance valueAt: #password).

	app := PWExampleApplication withLocator: PWRestfulLocator new.
	app addFactory: [:term | ALAuthenticationRelay destination: term
						authenticator: authenticator 
						shunt: nil].
	(ALServer on: (PWSeasidePrefsModel instance valueAt: #port) application: app) start 

! !

!PEGWikiTool class methodsFor: 'startup list' stamp: 'chc 6/23/2016 08:57'!
startUp: resuming
	self startPEGWiki! !

ALRestfulLocator subclass: #PWRestfulLocator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PW-Utilities'!

PWRestfulLocator class
	instanceVariableNames: 'singleton'!

PWRestfulLocator class
	instanceVariableNames: 'singleton'!

!PWRestfulLocator class methodsFor: 'singleton' stamp: 'chc 6/22/2016 08:49'!
initializeSingleton
	self singleton: (self strategy: ALRandomUrlStrategy new)! !

!PWRestfulLocator class methodsFor: 'singleton' stamp: 'chc 6/22/2016 08:51'!
random
	^ singleton ifNil: [self strategy: ALRandomUrlStrategy new]! !

!PWRestfulLocator class methodsFor: 'singleton' stamp: 'chc 6/22/2016 08:50'!
singleton
	^singleton! !

!PWRestfulLocator class methodsFor: 'singleton' stamp: 'chc 6/22/2016 08:50'!
singleton: anObject
	singleton := anObject! !
PEGWikiTool initialize!
